const system = require("../system");
const uuidv4 = require('uuid/v4');
const settings = require("../../config/settings");
class APIBase{
    constructor() {
        this.cacheManager = system.getObject("db.common.cacheManager");
    }
    async doexec(gname, methodname, pobj, query, req) {
        try {
            console.log("**********************************************")
            console.log(req.headers)
            let custtags=req.headers["x-consumetag"].split("|");
            req.xctx={
                appkey:req.headers["x-appkey"],
                companyid:custtags[0].split("_")[1],
                password:custtags[1].split("_")[1],
                username:req.headers["x-consumer-username"],
                credid:req.headers["x-credential-identifier"]
            }
            var rtn = await this[methodname](pobj, query, req);
            return rtn;
        } catch (e) {
            console.log(e.stack, "api调用异常--error...................");
            var rtnerror = system.getResultFail(-200, "出现异常，请联系管理员");
            return rtnerror;
        }
    }
}
module.exports = APIBase;

