const system = require("../system");
const settings = require("../../config/settings");
const uuidv4 = require('uuid/v4');
class CtlBase {
  constructor(gname, sname) {
    this.serviceName = sname;
    this.service = system.getObject("service." + gname + "." + sname);
    this.cacheManager = system.getObject("db.common.cacheManager");
  }
  static getServiceName(ClassObj) {

    return ClassObj["name"].substring(0, ClassObj["name"].lastIndexOf("Ctl")).toLowerCase() + "Sve";
  }
  async setContextParams(pobj, qobj, req) {
     req.xctx={
      appkey:req.headers["x-appkey"],
     }
  }
  async doexec(methodname, pobj, query, req) {
    try {
      await this.setContextParams(pobj, query, req);
      //从请求头里面取appkey_consumename
     // var consumeName=req.headers[""]
     // var appkey=
      // if( this.session["appkey_consumename"]) {

      // }else{
      //   //从头里取，从redis中取出缓存对象赋值到控制基类的session属性
      //   //appkey_consumename
      //   this.session={};
      // }
      //req.session=redis缓存的上下文对象
      var rtn = await this[methodname](pobj, query, req);
      return rtn;
    } catch (e) {
      console.log(e.stack, "出现异常，请联系管理员.......");
      return system.getResultFail(-200, "出现异常，请联系管理员");
    }
  }
}
module.exports = CtlBase;
