var system = require("../../../system")
const http = require("http")
const querystring = require('querystring');
var settings = require("../../../../config/settings");
const CtlBase = require("../../ctl.base");
var cacheBaseComp = null;
class UserCtl extends CtlBase {
  constructor() {
    super("auth", CtlBase.getServiceName(UserCtl));
  }

  async initNewInstance(queryobj, req) {
    var rtn = {};
    rtn.roles = [];
    return system.getResultSuccess(rtn);
  }
  //获取验证码，发送给指定手机
  async sendVCode(pobj, qobj, req) {
    var mobile = pobj.mobile;
    let v=await this.smsS.sendVCode(mobile);
    return system.getResult({ vcodestr: v });
  }
  async exit(pobj, qobj, req) {
   
  }
  async pmregister(pobj, qobj, req) {
    //平台注册设置平台的应用ID
    pobj.app_id=settings.pmappid;
    var rtn=await this.service.pmregister(pobj);
    return system.getResult(rtn);
  }
  async create(pobj, queryobj, req) {
    var rtn=await this.service.register(pobj);
    return system.getResult(rtn);
  }
  async pmlogin(pobj, qobj, req) {
    //平台注册设置平台的应用ID
    let rtn=await this.service.pmlogin(pobj, qobj,req);
    return system.getResult(rtn);
  }
  async pmloginByVCode(pobj, qobj, req){
    let rtn=this.service.pmloginByVCode(pobj, qobj);
    return system.getResult(rtn);
  }
  async sendVCode(pobj, qobj,req){
    let rtn=await this.service.sendVCode(pobj, qobj);
    return system.getResult(rtn);
  }
}
module.exports = UserCtl;
